//
//  Guit GUI Toolkit
//  Copyright © 2020 Eric Lecolinet. All rights reserved.
//  http://www.telecom-paris.fr/~elc
//

#include <guit.hpp>
#include "examples.hpp"
using namespace std;
using namespace guit;

class OnePage : public GWindow {
  // contains the name of the chosen fruit
  GText fruit;

public:
  OnePage() : GWindow("#one-page One page") {

    // Adds the gadgets to the GUI
    *this
    // strings are displayed as Labels in a GBox or a GWindow
    // #header  (or .header ) is a CSS style
    << "#header Hi Guit!"
    << "Click on your preferred fruit!"

    << (ScrollBox()
        // strings are displayed as (selectable) Items in a ListBox
        << (ListBox("#fruits")

            // called when one item of the ListBox is clicked
            // sets the text of the chosen item into 'fruit'
            << [this](GEvent& e) { if (auto* item = e.chosen()) fruit = item->text(); }

            // the items contains an image
            << "Oranges <img src=oranges.jpg height=30>"

            // this item has a tool tip
            << "{tip:mangoes} Mangos <img src=mangoes.jpg height=30>"

            // the tip contains an image
            << "{tip:apples <img src=apples.jpg height=30>} Apples <img src=apples.jpg height=30>"

            << "Bananas <img src=bananas.jpg height=30>"

            << "Peaches <img src=peaches.jpg height=30>"
            )
        )
    << (StatusBar
        // automatically updated when fruit's value is changed
        << ("Clicked fruit: <color:red>" + ~fruit)
        );
  }
};


GWindow& Examples::makeOnePage() {
  return *new OnePage;
}
