//
//  Builder
//  guit GUI Toolkit
//  Copyright © 2019 Eric Lecolinet. All rights reserved.
//  http://www.telecom-paristech.fr/~elc
//

#include <guit.hpp>
#include <gtrigger.hpp>
#include <gcond.hpp>
#include <gcursor.hpp>
/*
#include <gcolor.hpp>
#include <gfont.hpp>
#include <gtext.hpp>
#include <gpos.hpp>
#include <gsize.hpp>
#include <gitem.hpp>
#include <gtextitem.hpp>
#include <gslider.hpp>
#include <gtable.hpp>
#include <gchoicebox.hpp>
#include <gmenu.hpp>
#include <gwindow.hpp>
#include <gdialog.hpp>
#include <gfiledialog.hpp>
#include <gstates.hpp>
#include <gchart.hpp>
 */
#include <gcontrol.hpp>
#include <ginspector.hpp>
#include <gbuilder.hpp>
using namespace std;
namespace guit {

static const auto DefaultPosition = "500 500";
//static GBuilder* builder_{};

/*
void GApp::showBuilder(bool show, bool raise) {
  if (!show) {
    if (builder_) builder_->getWindow()->show(false);
  }
  else {
    showInspector(show, raise);  // creates inspector if needed
    if (!builder_) {
      builder_ = new GBuilder(*GApp::inspector());
    }
    if (!builder_->getWindow()->isShown()) builder_->getWindow()->show();
    if (raise) builder_->getWindow()->raise();
  }
}*/

/*
GBuilder* GApp::getBuilder(bool create_if_needed) {
  if (!builder_&& create_if_needed) {
    builder_ = new GBuilder(*GApp::getInspector(true));
  }
  return builder_;
}*/

GBuilder::GBuilder(GInspector& insp) :
GWindow("#buider Guit Builder"),
insp_(insp)
//, buildwin_(Window("Guit Builder"))
{
  setInternal();;
  ignoreSmartPointers();

  *this
  << new GPos(DefaultPosition)
  << (Table
      << Label("<b>Labels & Buttons")
      << (TRow
          << newButton(GLabel::Type())
          << newButton(GFiller::Type())
          << newButton(GSeparator::Type())
          )
      << (TRow
          << newButton(GButton::Type())
          << newButton(GItem::Type())
          << newButton(GLinkItem::Type())
          )
      << (TRow
          << newButton(GCheckItem::Type())
          << newButton(GRadioItem::Type())
          << newButton(GChoiceItem::Type())
          )
      << Label("<b>Text, etc.")
      << (TRow
          << newButton(GTextField::Type())
          << newButton(GTextArea::Type())
          << newButton(GSlider::Type())
          )
      << Label("<b>Boxes & Frames")
      << (TRow
          << newButton(GVBox::Type())
          << newButton(GHBox::Type())
          << newButton(GStackBox::Type())
          )
      << (TRow
          << newButton(GChoiceBox::Type())
          << newButton(GListBox::Type())
          << newButton(GRadioBox::Type())
          )
      << (TRow
          << newButton(GOptionBox::Type())
          << newButton(GComboBox::Type())
          << newButton(GTabBox::Type())
          )
      << Label("<b>Bars")
      << (TRow
          << newButton(GMenuBar::Type())
          << newButton(GToolBar::Type())
          << newButton(GStatusBar::Type())
          )
      << Label("<b>Tables")
      << (TRow
          << newButton(GTable::Type())
          << newButton(GTRow::Type())
          << newButton(GTHead::Type())
          )
      << Label("<b>Windows & Menus")
      << (TRow
          << newButton(GMenu::Type())
          << newButton(GWindow::Type())
          << newButton(GDialog::Type())
          )
      << (TRow
          << newButton(GInfoDialog::Type())
          << newButton(GFileDialog::Type())
          )
      << Label("<b>Charts")
      << (TRow
          << newButton(GChartBox::Type())
          << newButton(GChartItem::Type())
          )
      );
}


Gadget& GBuilder::newButton(GadgetType& m) {
  auto& btn = Button(m.name());
  btn << on::mousedown / [this,&btn,&m]{
    GCursor::cursor()->startDrag(btn, [&](GCursor& c){newGadgetCB(c,m);});
  };
  return btn;
}

void GBuilder::newGadgetCB(GCursor& c, GadgetType& m) {
  auto* btn = c.source();
  if (!btn) return;
  btn->modes_.active = false;          // must be done because of grab  !!
  btn->update();                          // needed after setActivated()
  gptr<Gadget> g = m.newInstance(m.name());    // g destroyed if not added
  insp_.moveGadget(c, *g);
}
}
