//
//  Dynamic loading of Guit scripts
//  Guit GUI Toolkit
//  Copyright © 2019-2020 Eric Lecolinet. All rights reserved.
//  http://www.telecom-paris.fr/~elc
//

#ifndef Guit_Script_hpp
#define Guit_Script_hpp
#include <gobjectbase.hpp>
namespace guit {

/// Loads Guit code from a file or a string buffer.
class GLoader {
public:
  /// Loads Guit code from a file.
  /// Magic prefix characters ~ and : are respectively replaced by the home and the resource directory
  /// @see GIn.
  static Gadget* loadFile(GString const& filename,
                          GObjectBase* = {},
                          GTextAttributes* = {});

  /// Loads Guit code from a string buffer.
  static Gadget* loadBuffer(GString const& buffer,
                            GObjectBase* = {},
                            GTextAttributes* = {});

  /// Loads Guit code from a stream.
  static Gadget* load(std::istream& stream,
                      GObjectBase* = {},
                      GTextAttributes* = {},
                      GString const& streamname = "");
};

}
#endif
